'''
Created on 17 janv. 2020

@author: invite
'''
from mako.runtime import _populate_self_namespace
'''
Created on 3 nov. 2018

@author: invite

'''
import random
import Conf
from BlocGroup import BlocGroup
from Bloc import Bloc


class Wall(BlocGroup):
    '''
    classdocs
    '''


    def __init__(self,** keys):
        
        random.seed()
        self.c=[]
        self.w=[]
        self.long=2
        self.stairs=1.5
        
        if 'blocSize' in keys :
            self.blocSize=keys['blocSize']
        else:
            print("Wall need blocSize")
            
        if 'blocSz' in keys :
            self.blocSz=keys['blocSz']
        else:
            print("Wall need blocSz") 
        
        if 'ratioLong' in keys :
            self.ratioLong=keys['ratioLong']
        else:
            self.ratioLong=0.3
        
        if 'ratioEmptySpace' in keys :
            self.ratioEmptySpace=keys['ratioEmptySpace']
        else:
            self.ratioEmptySpace=0.15
        
        
        if 'nbRow' in keys :
            self.nbRow=keys['nbRow']
        else:
            self.nbRow=3
        
        if 'color' in keys :
            self.color=keys['color']
        else:
            self.color=Conf.colorRouge
                        
        if 'colorStairs' in keys :
            self.colorStairs=keys['colorStairs']
        else:
            self.colorStairs=Conf.colorOrange
            
        if 'colorLong' in keys :
            self.colorLong=keys['colorLong']
        else:
            self.colorLong=Conf.colorJaune
                
        """            
        if 'wpx' in keys :
            self.wpx=keys['wpx']
        else:
            self.wpx=random.randint(0,2*Conf.worldSize())
        """
            
        if 'py' in keys :
            self.wpy=keys['py']
        else:
            self.wpy=random.randint(0,2*Conf.worldSize())
        
        self.n=int((2*Conf.worldSize)/(2*self.blocSize))+1
        self.mid=int(self.n/2)+1

        

    def drawWall(self):
        mid=self.mid
        sx=self.blocSize
        sy=self.blocSize
        
        m="  - -"
        M=["----","=---","-- -","- = ","-- -"]
        
        r=0
        for i in m:
            self.addBloc(m[r],Conf.worldSize,r*self.blocSz)
            b=0
            for j in range(1,mid):
                self.addBloc(M[r][b],Conf.worldSize+(j*(self.blocSize*2)),r*self.blocSz)
                self.addBloc(M[r][b],Conf.worldSize-(j*(self.blocSize*2)),r*self.blocSz)
                if b+1==len(M[r]):
                    b=0
                else:
                    b+=1
            r+=1
        
        
        
    def addBloc(self,o,px,pz):
        sx=self.blocSize
        py=self.wpy
        sz=self.blocSz
        if o==" ":
            return
        
        if o=="-":
            sy=self.blocSize
            color=Conf.colorRouge
        elif o=="=":
            sy=self.blocSize*2
            color=Conf.colorJaune
            
            
        self.c.append(Bloc(sx=sx,sy=sy,sz=sz,py=py,px=px,pz=pz,rotation=0,type="meshbox", color=color))
                          
                    
            
            
 
        
    def drawStairsWall(self):
        mid=int(self.n/2)
        #init wall grid with stairs ( long blocs)
        for r in range(0,self.nbRow):
            self.w.append([])
            for i in range(0,self.n):
                if i==mid+r or i==mid-r :
                    self.w[r].append("Stairs")
                else:
                    self.w[r].append(True)
                
        
        # make empty space
        for r in range(0,self.nbRow):
            for i in range(0,self.n):
                if self.w[r][i]!="Stairs":
                    if r>0 and self.w[r-1][i]==None :
                            self.w[r][i]=(True)
                    else:
                        if random.random()<self.ratioEmptySpace :
                                self.w[r][i]=(None)

    
        
        # from matrice to blocs
        for r in range(0,self.nbRow):
            pz=0+(r*self.blocSz)

                        
            for i in range(0,self.n):
                sx=self.blocSize
                sy=self.blocSize
                color=self.color
                
                if self.w[r][i]=="Stairs":
                    sx=self.blocSize
                    sy=self.stairs*self.blocSize
                    color=self.colorStairs
                elif random.random()<self.ratioLong and self.w[r-1][i]!="Stairs":
                    sx=self.blocSize
                    sy=self.long*self.blocSize
                    color=self.colorLong
                            
                if self.w[r][i]!=None:
                    
                    self.c.append(Bloc(sx=sx,sy=sy,sz=self.blocSz,py=self.wpy,px=i*(self.blocSize*2),pz=pz,rotation=0, 
                                            type="meshbox", color=color,
                                            name="wall r="+str(r)+" / n="+str(i)))
                else:
                    if self.nbRow-1==r:
                        self.c.append(Bloc(sx=sx,sy=sy,sz=1,py=self.wpy,px=i*(self.blocSize*2),pz=pz-self.blocSz,rotation=0, 
                                            type="zone",option="zoneflag SW 1",
                                            name="wall zoneflag r="+str(r)+" / n="+str(i)))
                        
              
                        
                        
                
    def drawBigJumpWall(self):
        for r in range(0,self.nbRow):
            self.w.append([])
            for i in range(0,self.n):
                if random.random()<self.ratioEmptySpace :
                    self.w[r].append(None)
                elif random.random()<self.ratioLong:
                    self.w[r].append("Long")
                else:
                    self.w[r].append(True)
        
         # from matrice to blocs
        for r in range(0,self.nbRow):
            pz=0+(r*self.blocSz)

                        
            for i in range(0,self.n):
                sx=self.blocSize
                sy=self.blocSize
                color=self.color
                
                if self.w[r][i]=="Long":
                    if random.random()<0.5:
                        q=1
                    else:
                        q=0
                        
                    self.c.append(Bloc(sx=sx,sy=self.long*self.blocSize,sz=self.blocSz/2,py=self.wpy,px=i*(self.blocSize*2),pz=pz+(q*(self.blocSz/2)),rotation=0, 
                                            type="meshbox", color=self.colorLong,
                                            name="wall r="+str(r)+" / n="+str(i)))
                    #sx=self.blocSize
                    #sy=self.long*self.blocSize
                    #color=self.colorLong
                            
                if self.w[r][i]!=None:
                    
                    self.c.append(Bloc(sx=sx,sy=sy,sz=self.blocSz,py=self.wpy,px=i*(self.blocSize*2),pz=pz,rotation=0, 
                                            type="meshbox", color=color,
                                            name="wall r="+str(r)+" / n="+str(i)))
                else:
                    if self.nbRow-1==r:
                        self.c.append(Bloc(sx=sx,sy=sy,sz=1,py=self.wpy,px=i*(self.blocSize*2),pz=pz-self.blocSz,rotation=0, 
                                            type="zone",option="zoneflag SW 1",
                                            name="wall zoneflag r="+str(r)+" / n="+str(i)))
                        
            return         
        