'''
Created on 1 juin 2020

@author: invite
'''
import random
import Conf
from BlocGroup import BlocGroup
from Bloc import Bloc
import StepBloc

class Builder(BlocGroup):
    '''
    classdocs
    
    x bloc
    xs bloc shootthrough
    xp bloc passthrough
    _ empty
    > pyra
    < inverse pyra
    '''
    


    def __init__(self, ** keys):
        '''
        Constructor
        '''
        if 'px' in keys :
            self.px=keys['px']
        else:
            self.px=random.randint(0,2*Conf.worldSize)
            
        if 'py' in keys :
            self.py=keys['py']
        else:
            self.py=random.randint(0,2*Conf.worldSize)
            
        self.pz=0
        
        if 'sy' in keys :
            self.sy=keys['sy']
        else:
            self.sy=random.randint(Conf.blocSyMin,Conf.blocSyMax)
            
        if 'sx' in keys :
            self.sx=keys['sx']
        else:
            self.sx=random.randint(Conf.blocSxMin,Conf.blocSxMax)
            
        if 'sz' in keys :
            self.sz=keys['sz']
        else:
            self.sz=random.randint(Conf.blocSzMin,Conf.blocSzMax)
        
        if 'protection' in keys :
            self.protection=keys['protection']
        else:
            self.protection=1
            
        if 'rotation' in keys :
            self.rotation=keys['rotation']
        else:
            self.rotation=0
            
        if 'matrice' in keys :
            self.m=keys['matrice']
        else:
            print.err("Builder need matrice")
            exit(1)
            
        self.c=[]

        
    def gen(self):
        
        pz=self.pz
        for level in self.m:
            py=self.py
            for row in level:
                px=self.px
                for bloc in row:
                    
                    if bloc=="x":
                        self.c.append(Bloc( \
                            px=px,\
                            py=py,\
                            pz=pz,\
                            sx=self.sx, \
                            sy=self.sy, \
                            sz=self.sz,\
                            protection=self.protection,\
                            rotation=self.rotation,\
                            type="meshbox"))
                        
                    elif bloc=="xs":
                        self.c.append(Bloc( \
                            px=px,\
                            py=py,\
                            pz=pz,\
                            sx=self.sx, \
                            sy=self.sy, \
                            sz=self.sz,\
                            protection=self.protection,\
                            shootthrough=True,\
                            rotation=self.rotation,\
                            type="meshbox"))    
                    elif bloc=="xp":
                        self.c.append(Bloc( \
                            px=px,\
                            py=py,\
                            pz=pz,\
                            sx=self.sx, \
                            sy=self.sy, \
                            sz=self.sz,\
                            protection=self.protection,\
                            drivethrough=True,\
                            rotation=self.rotation,\
                            type="meshbox"))   
                    elif bloc==">":
                        self.c.append(Bloc( \
                            px=px,\
                            py=py,\
                            pz=pz,\
                            sx=self.sx, \
                            sy=self.sy, \
                            sz=self.sz,\
                            protection=self.protection,\
                            rotation=self.rotation,\
                            type="pyramid"))   
                    elif bloc=="<":
                        self.c.append(Bloc( \
                            px=px,\
                            py=py,\
                            pz=-pz,\
                            sx=self.sx, \
                            sy=self.sy, \
                            sz=self.sz,\
                            protection=self.protection,\
                            rotation=self.rotation,\
                            type="pyramid"))   
                    elif bloc=="_":
                        pass
                    else:
                        print.err("Builder wrong type fo bloc: "+StepBloc)
                        exit(1)
                    px+=2*self.sx
                
                py+=2*self.sy
                
            pz+=self.sz
            