'''
Created on 4 nov. 2018

@author: invite
'''
import random
import Conf
from Collection import Collection
from BlocGroup import BlocGroup

class Forest(BlocGroup):
    '''
    classdocs
    '''
    def __init__(self, ** keys):
     
        BlocGroup.__init__(self)
        random.seed()
        
        self.shX=0
        self.shY=0
        self.shZ=0

        if 'px' in keys :
            self.px=keys['px']
        else:
            self.px=random.randint(0,2*Conf.worldSize)
            
        if 'py' in keys :
            self.py=keys['py']
        else:
            self.py=random.randint(0,2*Conf.worldSize)
            
        if 'sx' in keys :
            self.sx=keys['sx']
        else:
            self.sx=None
            
        if 'sy' in keys :
            self.sy=keys['sy']
        else:
            self.sy=None

        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"

        if 'collection' in keys :
            self.c=keys['collection'].getList()
        else:
            self.c=None
            
        """    
        if 'posxmax' in keys :
            self.posxmax=keys['posxmax']
        else:
            print("forest need posxmax")
            exit()
            
        if 'posymax' in keys :
            self.posymax=keys['posymax']
        else:
            print("forest need posymax")
            exit()
        
            
        if 'shX' in keys :
            self.shX=keys['shX']
        if 'shY' in keys :
            self.shY=keys['shY']
        """

            
        #if self.shX != 0 or self.shY !=0:
        #    self.shift()
            
        if self.sx is None or self.sy is None:
            surface=random.randint(0,Conf.ratioForestSize*(Conf.worldSize**2))
            self.sx=random.randint(Conf.forestLongMin, Conf.worldSize)
            self.sy=round(surface/self.sx)
            if self.sy > Conf.worldSize:
                self.sy = Conf.worldSize - 1
        else: 
            surface=self.sx*self.sy
        
        densite=random.uniform(Conf.densiteForestMin,Conf.densiteForestMax)
        
        #*******************************
        #* generation d une collection
        rotation=self.randRotation()
        protection=Conf.protectionForest
        type=self.randType()
        
        #*taille fixe
        
        if random.random() < Conf.ratioTailleFixe:
                    
            sizeX=random.randint(Conf.forestSizeXmin,Conf.forestSizeXmax)
            #on evite les rectrangles trop long, pour eviter les trou a drapeau
            sizeY=random.randint(Conf.forestSizeYmin,Conf.forestSizeYmax)
            #if sizeY > 2*sizeX:
            #    sizeY=2*sizeX
            sizeZ=random.randint(Conf.forestSizeZmin,Conf.forestSizeZmax)
            
            nb=round( (self.sx*self.sy*densite)/( sizeX * sizeY ) )
            
            self.c=Collection(nb=nb,protection=protection,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation,name="Forest").getList()
            
            #*taille variable
            
        else:
    
            sizeXmax=random.randint(1,Conf.forestSizeXmax)
            sizeYmax=random.randint(1,Conf.forestSizeYmax)
            sizeZmax=random.randint(1,Conf.forestSizeZmax)
            
            nb=int((self.sx*self.sy*densite)/ (((sizeXmax+Conf.forestSizeXmin)/2)*((sizeYmax+Conf.forestSizeYmin)/2)) )
            
            self.c=Collection(nb=nb,protection=protection,type=type,sizeXmin=Conf.forestSizeXmin, \
                         sizeYmin=Conf.forestSizeYmin,sizeZmin=Conf.forestSizeZmin, \
                         sizeXmax=sizeXmax,sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation,name="Forest").getList()
                        
        for o in self.c:
            o.setPx(random.randint(self.px-self.sx,self.px+self.sx))
            o.setPy(random.randint(self.py-self.sy,self.py+self.sy))
            
        
    def randRotation(self):
        random.seed()

        if random.random() > Conf.ratioRotationRandom :
            rotation=0
        else:
            rotation=random.randint(0,360)
            #if random.random() < 0.5:
            #    rotation=0
            #else:
            #    rotation=45
                
        return rotation
